#include <iostream>

#include "jabatoSchedule.h"

void jabatoBlocksHandler::findBlocks(QList<JabatoBlock> *b)
{
  blocks = b;
  m_error = false;
}


bool
jabatoBlocksHandler::error(){
  return m_error;
}

jabatoBlocksHandler::jabatoBlocksHandler()
{
  //I BET YOU KNOW HOW TO THIS MUCH BETTER. THEY ARE USED AS SIMPLE CONSTANTS!!
  BLOCK = XMLString::transcode("BLOCK");

  ID = XMLString::transcode("ID");
  NAME = XMLString::transcode("NAME");

	HREF = XMLString::transcode("HREF");
	JABATOS = XMLString::transcode("JABATOS");
	IMG = XMLString::transcode("IMG");
	BKIMG = XMLString::transcode("BKIMG");
	EMAIL = XMLString::transcode("EMAIL");

  block = NULL;
  m_error = false;
}

jabatoBlocksHandler::~jabatoBlocksHandler()
{
  //I BET YOU KNOW HOW TO DO THIS MUCH BETTER. THEY ARE USED AS SIMPLE CONSTANTS!!
  delete BLOCK;
  delete ID;
  delete NAME;
	delete HREF;
	delete JABATOS;
	delete IMG;
	delete BKIMG;
	delete EMAIL;

}

// ---------------------------------------------------------------------------
//  jabatoBlocksHandler: Overrides of the SAX ErrorHandler interface
// ---------------------------------------------------------------------------
void jabatoBlocksHandler::error(const SAXParseException& e)
{
    cerr << "\nError at file " << StrX(e.getSystemId())
		     << ", line " << e.getLineNumber()
    		 << ", char " << e.getColumnNumber()
         << "\n  Message: " << StrX(e.getMessage()) << endl;
    m_error = true;
}

void jabatoBlocksHandler::fatalError(const SAXParseException& e)
{
    cerr << "\nFatal Error at file " << StrX(e.getSystemId())
    		 << ", line " << e.getLineNumber()
	    	 << ", char " << e.getColumnNumber()
         << "\n  Message: " << StrX(e.getMessage()) << endl;
  m_error = true;
}

void jabatoBlocksHandler::warning(const SAXParseException& e)
{
  cerr << "\nWarning at file " << StrX(e.getSystemId())
  		 << ", line " << e.getLineNumber()
	  	 << ", char " << e.getColumnNumber()
       << "\n  Message: " << StrX(e.getMessage()) << endl;
  m_error = true;
}

// ---------------------------------------------------------------------------
//  jabatoBlocksHandler: Overrides of the SAX DocumentHandler interface
// ---------------------------------------------------------------------------
void jabatoBlocksHandler::endElement(const XMLCh* const uri,
								 const XMLCh* const localname,
								 const XMLCh* const qname)
{
  if(XMLString::compareIString(qname, BLOCK)==0)
    block = NULL;
}


void jabatoBlocksHandler::characters(const XMLCh* const chars, const unsigned int length) {
  if(block!=NULL) {
    char *transcoded = XMLString::transcode(chars);
    block->setDescription(transcoded);
    delete transcoded;
  }
}


void jabatoBlocksHandler::startElement(const   XMLCh* const    uri,
									const   XMLCh* const    localname,
									const   XMLCh* const    qname,
                                    const   Attributes&		attributes)
{
  if(XMLString::compareIString(qname, BLOCK)==0)
  {
    char *transcoded = NULL;
    uint id;
    try
    {
      if (XMLString::textToBin(attributes.getValue(ID), id)) {
        transcoded = XMLString::transcode(attributes.getValue(NAME));
        block = new JabatoBlock(id,transcoded);
        delete transcoded;
        blocks->append(block);

        unsigned int len = attributes.getLength();
        for (unsigned int index = 0; index < len; index++)
        {
			    if (XMLString::compareIString(attributes.getQName(index),HREF) == 0) {
            transcoded = XMLString::transcode(attributes.getValue(index));
			      block->setHRef(transcoded);
            delete transcoded;
			    }
			    else if (XMLString::compareIString(attributes.getQName(index),JABATOS) == 0) {
            transcoded = XMLString::transcode(attributes.getValue(index));
			      block->setJabatos(transcoded);
            delete transcoded;
			    }
			    else if (XMLString::compareIString(attributes.getQName(index),IMG) == 0) {
            transcoded = XMLString::transcode(attributes.getValue(index));
			      block->setImage(transcoded);
            delete transcoded;
			    }
			    else if (XMLString::compareIString(attributes.getQName(index),BKIMG) == 0) {
            transcoded = XMLString::transcode(attributes.getValue(index));
			      block->setBackImage(transcoded);
            delete transcoded;
			    }
			    else if (XMLString::compareIString(attributes.getQName(index),EMAIL) == 0) {
            transcoded = XMLString::transcode(attributes.getValue(index));
			      block->setEmail(transcoded);
            delete transcoded;
			    }
        }
      }
    }
    catch (...)
    {
      if(transcoded) delete transcoded;
    }
  }
}

