#include <qobjectlist.h>

#include <sax2/Attributes.hpp>
#include <sax2/DefaultHandler.hpp>


class jabatoBlocksHandler : public DefaultHandler
{
public:
    jabatoBlocksHandler();
    ~jabatoBlocksHandler();

    void findBlocks(QList<JabatoBlock> *);
    bool error();

    // -----------------------------------------------------------------------
    //  Implementations of the SAX DocumentHandler interface
    // -----------------------------------------------------------------------
    void endElement(const XMLCh* const uri,
		                      						 const XMLCh* const localname,
		                      						 const XMLCh* const qname);
    void characters(const XMLCh* const chars, const unsigned int length);

    void startElement(	const   XMLCh* const    uri,
						const   XMLCh* const    localname,
						const   XMLCh* const    qname,
				    const   Attributes&		attributes);

				
    // -----------------------------------------------------------------------
    //  Implementations of the SAX ErrorHandler interface
    // -----------------------------------------------------------------------
    void warning(const SAXParseException& exception);
    void error(const SAXParseException& exception);
    void fatalError(const SAXParseException& exception);

private :
//	JabatoBlock *jabatoBlock[];
	bool      	 m_error;
  JabatoBlock *block;
  QList<JabatoBlock> *blocks;

	
  const XMLCh *BLOCK;

  const XMLCh *ID;
  const XMLCh *NAME;

	const XMLCh *HREF;
	const XMLCh *JABATOS;
	const XMLCh *IMG;
	const XMLCh *BKIMG;
	const XMLCh *EMAIL;

};
